<template>
  <div>
    <mt-page-title
      :with-border="false"
      with-padding
      link-text="retour au statistiques"
      :link-to="profilLink({ name: 'dashboard-statistiques-id-utilisateurs', params: { id: idOrganisme } })"
    >
      <h1 class="has-text-weight-bold is-size-3">Informations personnelles</h1>
    </mt-page-title>

    <mt-details-utilisateur
      no-modification
      :utilisateur="utilisateur"
      :activites="activites"
      :organismes="organismes"
      :disponibilites="disponibilites"
      :disponibilites-employe="disponibilitesEmploye"
      :disponibilites-annuel="disposAnnuel"
      :month-date="monthDate"
      :start-activite="startActivite"
      :end-activite="endActivite"
      :statistique="statistique"
      :type-activite="typeActivite"
      @mois-suivant="moisSuivant"
      @mois-precedent="moisPrecedent"
      @mois-selectionne="moisSelectionne"
      @debut-selectionne="debutSelectionne"
      @fin-selectionne="finSelectionne"
    />
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import { classResolver } from '~/components/mixins/activityMixin';
import { statistiqueMixin } from '~/components/mixins/statistiqueMixin';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtDetailsUtilisateur from '~/components/utilisateur/details-utilisateur';
import MtPageTitle from '~/components/base/page-title/index';

export default {
  components: {
    MtPageTitle,
    MtDetailsUtilisateur,
  },
  mixins: [classResolver, DayMonthMixin, statistiqueMixin],
  async asyncData({ $api, params }) {
    const now = new Date();
    const start = DateTime.fromJSDate(now)
      .startOf('month')
      .startOf('week');
    const end = DateTime.fromJSDate(now)
      .startOf('month')
      .plus({ weeks: 5 })
      .endOf('week');
    const startActivite = DateTime.fromJSDate(now)
      .minus({ year: 1 })
      .toJSDate();
    const endActivite = DateTime.fromJSDate(now).toJSDate();
    const monthDate = now;
    const idOrganisme = params.id;

    const utilisateur = await $api.utilisateurs.getWithMyGroupe(params.utilisateur);
    const [organismes, activites, disponibilites, disposAnnuel] = await Promise.all([
      $api.organisme(utilisateur.affectation.organisme.id).organismesByEnfantOrderByHierarchie(),
      $api
        .utilisateur(utilisateur.id)
        .activitesParticipationEntre(
          DateTime.fromJSDate(startActivite).toISO(),
          DateTime.fromJSDate(endActivite).toISO(),
        ),
      $api.utilisateur(utilisateur.id).disponibilitesEntre(start.toISO(), end.toISO()),
      $api.utilisateurs.disponibilitesAnnuel(utilisateur.id, DateTime.fromJSDate(monthDate).toISO()),
    ]);
    const disponibilitesEmploye = [];
    disponibilites.forEach((disponibilite) => {
      disponibilitesEmploye[DateTime.fromISO(disponibilite.dateDebut).toISODate()] = disponibilite;
    });
    const statistique = await $api.statistiques.statistiqueUtilisateur(
      DateTime.fromJSDate(startActivite).toISO(),
      DateTime.fromJSDate(endActivite).toISO(),
      utilisateur.id,
    );
    const typeActivite = await $api.typesActivites.allOrder();

    return {
      organismes,
      utilisateur,
      disponibilites,
      activites,
      monthDate,
      startActivite,
      endActivite,
      disponibilitesEmploye,
      idOrganisme,
      disposAnnuel,
      statistique,
      typeActivite,
    };
  },
  methods: {
    async moisSelectionne(date) {
      this.monthDate = date;

      const start = DateTime.fromJSDate(this.monthDate)
        .startOf('month')
        .startOf('week');
      const end = DateTime.fromJSDate(this.monthDate)
        .startOf('month')
        .plus({ weeks: 5 })
        .endOf('week');

      this.disponibilites = await this.$api
        .utilisateur(this.utilisateur.id)
        .disponibilitesEntre(start.toISO(), end.toISO());
      this.disposAnnuel = await this.$api.utilisateurs.disponibilitesAnnuel(
        this.utilisateur.id,
        DateTime.fromJSDate(this.monthDate).toISO(),
      );
      this.disponibilitesEmploye = [];
      this.disponibilites.forEach((disponibilite) => {
        this.disponibilitesEmploye[DateTime.fromISO(disponibilite.dateDebut).toISODate()] = disponibilite;
      });
    },
    debutSelectionne(date) {
      this.startActivite = date;
      this.rechargerActivite();
    },
    finSelectionne(date) {
      this.endActivite = date;
      this.rechargerActivite();
    },
    async rechargerActivite() {
      this.activites = await this.$api
        .utilisateur(this.utilisateur.id)
        .activitesParticipationEntre(
          DateTime.fromJSDate(this.startActivite).toISO(),
          DateTime.fromJSDate(this.endActivite).toISO(),
        );
      this.statistique = await this.$api.statistiques.statistiqueUtilisateur(
        DateTime.fromJSDate(this.startActivite).toISO(),
        DateTime.fromJSDate(this.endActivite).toISO(),
        this.utilisateur.id,
      );
    },
    moisPrecedent() {
      const futureDateCourante = new Date(this.monthDate.setMonth(this.monthDate.getMonth() - 1));
      this.moisSelectionne(futureDateCourante);
    },
    moisSuivant() {
      const futureDateCourante = new Date(this.monthDate.setMonth(this.monthDate.getMonth() + 1));
      this.moisSelectionne(futureDateCourante);
    },
  },
};
</script>

<style scoped lang="scss"></style>
